#This program gives the simulated critical values for the test statistics reported in Table 1
#The default setting is the first row in Table 1
require(fracdiff)

#first estimate the model
data<-matrix(scan("data.txt", n = 19868), 19868, 1, byrow = TRUE)
y=data*100;

y<-y-mean(y)
y<-log(y^2+0.001)
mFD <- fracdiff( y, nar = 1, nma = 1)
d<-coef(mFD)[1]
ar1<-coef(mFD)[2]
ma1<-coef(mFD)[3]


n<-length(y)
rep2<-5000
m1<-round(n^(1/3))
m2<-round(n^(1/2))
bm<-rep(0,n)
rejf<-c(0,0)
sim_cv<-matrix(rep(0,2*rep2),nrow=rep2,ncol=2)

for (simu in 1:rep2)
{

r<-fracdiff.sim(n=n,ar=ar1,ma=ma1,d=d,n.start=100,mu=0)
y<-r$series
sim_cv[simu,]<-stats(y)
}
sim_cv[,1]=sort(sim_cv[,1])
sim_cv[,2]=sort(sim_cv[,2])

print ("10% cv for the mean and sup-t_d tests")
print (sim_cv[(0.90*rep2),1])
print (sim_cv[(0.90*rep2),2])
print ("******");
print ("5% cv for the mean and sup-t_d tests")
print (sim_cv[(0.95*rep2),1])
print (sim_cv[(0.95*rep2),2])
print ("******");
print ("1% cv for the mean and sup-t_d tests")
print (sim_cv[(0.99*rep2),1])
print (sim_cv[(0.99*rep2),2])
print ("******");






stats<-function(series)
{
T<-length(series)
m1<-round(T^(1/3))
m2<-round(T^(1/2))
bm<-rep(0,T)
sper<-fft(series)
sper<-log(abs(sper)^2/T);
for ( m in m1:m2)
{
         
    freq=seq(1,m, by=1)*(2*pi/T);
    reg<--(1/2)*log((1-cos(freq))^2+sin(freq)^2)
    fits<-lm(sper[2:(m+1)]~reg)
    bm[m]<-coefficients(fits)[2]/2
}
sbm<-bm-bm[m2]
mu=seq(1,T,by=1)*24/(pi*pi);
stat=sbm*sqrt(mu);
av_stat<-mean(stat[m1:(2*m1)])
max_stat<-max(stat[m1:(2*m1)])
dtest=c(av_stat,max_stat)
dtest
}