require(fracdiff)
options(warn=-1)

#generate data for Figure 10
n<-2^13
rep<-500
data<-matrix(0,n,rep)
for (j in 1:rep)
{
r<-fracdiff.sim(n=n,ar=0,ma=0.0,d=0.457,mu=0)
y=r$series
y1=y-mean(y)
data[,j]<-y1
}
write.table(data, file = "arfima-pure.txt", sep=" ", row.names = FALSE,col.names=FALSE)

#generate data for Figure 11
n<-2^13
rep<-500
data<-matrix(0,n,rep)
pjump<-12
qjump<-1.679
for (j in 1:rep)
{
r<-fracdiff.sim(n=n,ar=0.0,ma=0.0,d=0.457,mu=0)
y=r$series
eta<-runif(n,0,1)
eta=(eta<=(pjump/n))
v<-rnorm(n,mean=0,sd=1)
for (i in 1:n)
{
 if (eta[i]==TRUE)
    {eta[i]=eta[i]*rnorm(1,mean=0,sd=1)*qjump
    }
}

ut=cumsum(eta)
y<-y+ut
y1=y-mean(y)
data[,j]<-y1

}
write.table(data, file = "fractal_level.txt", sep=" ", row.names = FALSE,col.names=FALSE)
